package  
{
	import flash.utils.ByteArray;
	import mx.core.ByteArrayAsset;
	import org.flixel.*;
	import org.flixel.plugin.photonstorm.*;
	
	import flash.text.TextField;
	

	
	
	public class PlayState extends FlxState 
	{
		[Embed(source="../assets/test/mapCSV_level1_Solids.csv", mimeType="application/octet-stream")] public var levelTestSolids:Class;
		[Embed(source="../assets/test/mapCSV_level1_blue.csv", mimeType="application/octet-stream")] public var LevelBlue:Class;
		[Embed(source = "../assets/test/mapCSV_level1_green.csv", mimeType = "application/octet-stream")] public var LevelGreen:Class;
		[Embed(source = "../assets/test/mapCSV_level1_orange.csv", mimeType = "application/octet-stream")] public var LevelOrange:Class;
		[Embed(source = "../assets/test//mapCSV_level1_yellow.csv", mimeType = "application/octet-stream")] public var LevelYellow:Class;
		[Embed(source = "../assets/test/mapCSV_level1_piques.csv", mimeType = "application/octet-stream")]public var piquesLevel:Class;
		
		[Embed(source = "../assets/test/coins.csv", mimeType = "application/octet-stream")]public var _coinsMap:Class;
		[Embed(source = "../assets/test/checkpoints.csv", mimeType = "application/octet-stream")]public var _checkMap:Class;
		[Embed(source = "../assets/test/movablesV.csv", mimeType = "application/octet-stream")]public var _movablesVMap:Class;
		
		[Embed(source = "../assets/tilemap.PNG")]public var Tilemap:Class;
		
		

		
		
		
		public var _DebugText:FlxText;
		public var _Timer:Number;
		
		public var _solids :FlxTilemap = new FlxTilemap;
		public var _colorBlue :FlxTilemap = new FlxTilemap;
		public var _colorGreen :FlxTilemap = new FlxTilemap;
		public var _colorOrange:FlxTilemap = new FlxTilemap;
		public var _colorYellow :FlxTilemap = new FlxTilemap;
		public var _piques : FlxTilemap = new FlxTilemap;
		
		public var sayText : FlxText;
		
		public var movablesVObj : FlxGroup;
		public var movables : MovableV;
		public var solidsGroup:FlxGroup;
		
		public var potatoes : Coin;
		public var potatoesGroup : FlxGroup;
		
		public var player:Player;
		
		public var coinsParsed:ByteArrayAsset;
		public var checkParsed:ByteArrayAsset;
		public var movablesVparsed:ByteArray;
		
		
		public var FinalScore : FlxText;
		
		override public function create() :void
		{
			
			
			if (FlxG.getPlugin(FlxSpecialFX) == null)
			{
				FlxG.addPlugin(new FlxSpecialFX);
			}
			

			movablesVObj = new FlxGroup();
			solidsGroup = new FlxGroup();
			potatoesGroup = new FlxGroup();
			_Timer = 0;
			FlxG.bgColor = 0xFF252525;
			
			add(_colorBlue.loadMap(new LevelBlue, Tilemap, 16, 16));
			add(_colorGreen.loadMap(new LevelGreen, Tilemap, 16, 16));
			add(_colorOrange.loadMap(new LevelOrange, Tilemap, 16, 16));
			add(_colorYellow.loadMap(new LevelYellow, Tilemap, 16, 16));
			
			
			add(_solids.loadMap(new levelTestSolids, Tilemap, 16, 16));	
			solidsGroup.add(_solids);	
			Registry.solidsGroup = _solids;
			
			
			add(_piques.loadMap(new piquesLevel, Tilemap, 16, 16));
			
			
			add(player = new Player(50, 50));
			Registry.player = player;
			Registry.deathCount = 0 ;
			
			FlxG.camera.follow(player, 1);
			FlxG.camera.setBounds(0, 0, 200*16, 200*16);
			FlxG.worldBounds.width = 200*16;
			FlxG.worldBounds.height = 200*16;
			
			_DebugText = new FlxText(0, 0, 200, " DEBUG : ");
			_DebugText.setFormat(null, 8, 0xFFB9B9B9,null,0xFF141414);
			add(_DebugText);
			_DebugText.scrollFactor.x = _DebugText.scrollFactor.y = 0;
			
			sayText = new FlxText(player.x, player.y, 200 , "test");
			sayText.setFormat(null, 8, 0xFFE1E1E1, null, 0xFF141414);
			add(sayText);
			Registry.saySomething = sayText;
			
			coinsParsed = ByteArrayAsset(new _coinsMap() );
			placeCoins(coinsParsed.readUTFBytes(coinsParsed.length), Coin);
			
			checkParsed = ByteArrayAsset(new _checkMap() );
			placeCheckpoints(checkParsed.readUTFBytes(checkParsed.length), Checkpoint);
			
			movablesVparsed = ByteArrayAsset(new _movablesVMap() );
			placeMovablesV(movablesVparsed.readUTFBytes(movablesVparsed.length), MovableV);
			
			FinalScore = new FlxText(50, 50, 300, "");
			FinalScore.setFormat(null, 16, 0xFFB9B9B9,null,0xFF141414);
			add(FinalScore);
			FinalScore.scrollFactor.x = FinalScore.scrollFactor.y = 0;
			
		}
		
		
		override public function update():void 
		{
			sayText.x = player.x - sayText.size/2;
			sayText.y = player.y - 32;
			
			_Timer += FlxG.elapsed;
			_DebugText.text = "time : " + FlxU.formatTime(_Timer, true)+"\n" + potatoesGroup.countLiving() + " potatoes left";
			
			
			FlxG.collide(player, _solids);
			
			if (FlxG.keys.F2) FlxG.resetState();
			
			//FlxG.collide(movablesVObj, _solids);
			
			

			if (player.overlapsAt(player.x, player.y - 17, _solids))
			{
				player._canStandUp = false;
			}else player._canStandUp = true;
			
			
			if (_colorBlue.overlaps(player)) //////////:::::: BLUE
			{
				player._jumpSpeed = 260;
				player.maxVelocity.y = 220;
				player._gravity = 2; //changed
				player.drag.x = player._runSpeed * 2; //changed
				player._runSpeed = 175; //changed
				player._canJump = true;
				player._canSlide = false;
			}
			
			if (_colorGreen.overlaps(player)) //////////:::::: GREEN
			{
				player._jumpSpeed = 170;
				player.maxVelocity.y = 500;
				player._gravity = 10;
				player._runSpeed = 200; //changed
				player._canJump = true;
				player.drag.x = player._runSpeed * 8;
				player._canSlide = false;
			}
			
			if (_colorOrange.overlaps(player))//////////:::::: ORANGE
			{
				player._jumpSpeed = 170;
				player.maxVelocity.y = 500;
				player._gravity = 10;
				player._runSpeed = 140;
				player._canJump = false;
				player.drag.x = player._runSpeed * 8;
				player._canSlide = true;
			}
			if (_colorYellow.overlaps(player) && !_colorOrange.overlaps(player))//////////:::::: YELLOW
			{
				player._canSlide = false;
				player._jumpSpeed = 170;
				player.maxVelocity.y = 500;
				player._gravity = 10;
				player._runSpeed = 140;
				player._canJump = true;
				player.drag.x = player._runSpeed * 8;
			}
			
			if (_piques.overlaps(player))
			{
				player.Respawn();
			}

			
			FlxG.collide(_solids, movablesVObj);
			
			
		
			
			sayText.text = player._sayText;
			
			super.update();
			
			if (potatoesGroup.countLiving() <= 0) //////////////////////it's th end of the world as we know it
			{
				FlxG.timeScale = 0;
				Registry.FinalTime = _Timer;
				FinalScore.text = FlxU.formatTime( _Timer,true) + "\n" + "WITH " + Registry.deathCount.toString() + " DEATHS";
				trace(Registry.deathCount);
				
				
			}
			
			if (FlxG.timeScale == 0 && FlxG.keys.X)
			{
				FlxG.resetState();
				FlxG.timeScale = 1;
				Registry.deathCount = 0 ;
			}
		}
		
		
		public function placeCoins(CoinData:String, Sparkle:Class):void 
		{
		
			var coords:Array;
			var entities:Array = CoinData.split("\n");   // Each line becomes an entry in the array of strings
			
			for (var j:int = 0; j < entities.length-1; j++) 
			{
				coords = entities[j].split(",");  //Split each line into two coordinates
				add(potatoes =  new Coin(coords[0], coords[1]));
				potatoesGroup.add(potatoes);
				
			}
		}
		
		public function placeCheckpoints(checkData:String, Sparkle:Class):void 
		{
			
			var coords:Array;
			var entities:Array = checkData.split("\n");   // Each line becomes an entry in the array of strings
			
			for (var j:int = 0; j < entities.length-1; j++) 
			{
				coords = entities[j].split(",");  //Split each line into two coordinates
				add(new Checkpoint(coords[0], coords[1]));
			}
		}
		
			public function placeMovablesV(movablesVdata:String, Sparkle:Class):void 
		{
			
			var coords:Array;
			var entities:Array = movablesVdata.split("\n");   // Each line becomes an entry in the array of strings
			
			for (var j:int = 0; j < entities.length-1; j++) 
			{
				coords = entities[j].split(",");  //Split each line into two coordinates
				add( movables = new MovableV(coords[0], coords[1]));
				movablesVObj.add(movables);
			}
		}
		
		
		
		
		
	}

}