package  
{
	import org.flixel.*;
	import org.flixel.plugin.photonstorm.*;
	
	public class Player extends FlxSprite 
	{
		[Embed(source = "../assets/dany_walk.PNG")] public var danyStand:Class;
		
		[Embed(source = "../assets/SFX/death.mp3")]public var deathSxf:Class;
		[Embed(source = "../assets/SFX/jump.mp3")]public var jumpSfx:Class;
		[Embed(source = "../assets/SFX/slide.mp3")]public var slideSfx:Class;
		
		
		public var _runSpeed:int = 100;
		public var _gravity:int = 10;
		public var _jumpSpeed:int = 170;
		public var _canJump:Boolean = true;
		private var _jump:Number;
		public var _canSlide: Boolean = false;
		public var _canStandUp:Boolean = true;
		
		public var _fisting:Boolean = false;
		public var _fistTimer:Number = 0;
		public var timer:FlxDelay = new FlxDelay(3000);
		public var _sayText:String = "";
		
		public var respawnX:Number;
		public var respawnY:Number;
		
		private var RespawnTimer:FlxDelay;
		
		public var firstNomnom:Boolean = true;
		public var dead:Boolean = false;
		
		public var potatoCount:int = 0;
		
		public function Player(x:int , y:int):void
		{
			super(x, y);
			
			loadGraphic(danyStand, true, true,32,32);
			
			drag.x = _runSpeed * 8; // drag = décélération
			addAnimation("walk", [0, 1, 2, 3, 4, 5], 12, true);
			addAnimation("run", [0, 1, 2, 3, 4, 5], 16, true);
			addAnimation("slow", [0, 1, 2, 3, 4, 5], 12, true);
			addAnimation("stand", [6, 7, 8], 6 , true);
			addAnimation("fist", [9, 10 ,11,11,11,11,11], 8, false);
			addAnimation("fall", [13], 8, true);
			
			maxVelocity.y = 500;
			
			offset.x = 11;
			width = 10;
			RespawnTimer = new FlxDelay(600);
			RespawnTimer.start();
		}
		
		
		override public function update():void 
		{
			
			super.update();
			maxVelocity.x = _runSpeed;
						///////mouvements////////////
			acceleration.x = 0; //reset l'acceleration a zero si aucun boutton n'est utilisé
			
			if (!dead) {
				
			
			if (FlxG.keys.LEFT )
			{
				facing = LEFT;
				acceleration.x = -drag.x * _runSpeed;
			}
			else if (FlxG.keys.RIGHT)
			{
				facing = RIGHT;
				acceleration.x = drag.x * _runSpeed;
			}
			
			// jump mario style
			
			if((_jump >= 0) && (FlxG.keys.justPressed("X") && _canJump ))FlxG.play(jumpSfx);
				if((_jump >= 0) && (FlxG.keys.X) && _canJump ) //You can also use space or any other key you want
				{
					_fistTimer = 0;
					_jump += FlxG.elapsed;
					if(_jump > 0.25) _jump = -1; //You can't jump for more than 0.25 seconds
				}
				else _jump = -1;
	 
				if (_jump > 0)
				{
					if (_jump < 0.065)
					{
						
						velocity.y = -_jumpSpeed; //This is the minimum speed of the jump
					}
					else
						acceleration.y = 50; //The general acceleration of the jump
				} else
				{
					velocity.y += _gravity;  //Make the character fall after the jump button is released
				}
			
			if (isTouching(FLOOR))
			{
				 _jump = 0;
			}
			//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
			
			// FIGHT
			_fistTimer -= FlxG.elapsed
			if (_fistTimer <= 0)_fistTimer = 0;
			if (_fistTimer <= 0 && _fisting)
			{
				if (_canStandUp)
				{
					y -=16;
					offset.y = 0;
					height = 32;
					_fisting = false;
				
				}
			}
			
			if (FlxG.keys.justPressed("X") && _fistTimer ==0 && !_fisting && _canSlide && isTouching(FLOOR))
			{
				_fisting = true;
				_fistTimer = 0.8;
				y = y + 16;
				FlxG.play(slideSfx);
				
			}
			
			if (_fisting)
			{
				
				play("fist");
				
				drag.x = 0;
				if (_facing == RIGHT) velocity.x = 250;
				if (_facing == LEFT) velocity.x = -250;
				offset.y = 16;
				height = 14;
				
				
			}
			if (FlxG.keys.LEFT && FlxG.keys.RIGHT)
			{
				velocity.x = 0;
				acceleration.x = 0;
			}
			
			}
			
			//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
			
			//animations
			
			if (velocity.x != 0 && isTouching(FLOOR) && !_fisting)
			{
				if (_runSpeed < 100) play("walk");
				if (_runSpeed > 100) play("run");
				//if (_gravity < 10) play("slow");
			}else if(!_fisting)play("stand");
			//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
			if (!isTouching(FLOOR) && velocity.y > 0) play("fall");
			//TExt
			
			if ((RespawnTimer.hasExpired || RespawnTimer.secondsElapsed >1) && dead)
				{
					x = respawnX;
					y = respawnY - 16;
					dead = false;
				}
			
			
			if (timer.secondsElapsed < 1 && !firstNomnom)
			{
				_sayText = "NOM NOM NOM";
			}
			if (timer.secondsElapsed > 1)
			{
				_sayText = "";
			}
			
			trace(RespawnTimer.secondsElapsed);
		}
		
		public function saySomething():void 
		{
			firstNomnom = false;
			timer.start();
			timer.reset(3000);
			
		}
		
		public function Respawn():void 
		{
			
			if (!dead)
			{
				FlxG.play(deathSxf);
				dead = true;
				RespawnTimer.start();
				velocity.x = 0;
				velocity.y = 0;
				_fistTimer = 0;
				Registry.deathCount ++;
			}
			if ((RespawnTimer.hasExpired || RespawnTimer.secondsElapsed >1) && dead)
				{
					x = respawnX;
					y = respawnY - 16;
					dead = false;
				}
				
			
		}
		
		
		
	}

}